﻿Imports System.IO
Imports System.Threading

Public Class FormTerm

    Delegate Sub UpdateTextBoxSerialIn(ByVal str As String)
    '    Public myDelegate As UpdateTextBoxSerialIn
    Public myDelegate As New UpdateTextBoxSerialIn(AddressOf UpdateTextBoxSerialInMethod)

    Structure readerInput
        Dim readData As String
        Dim readCount As Long
        Dim readTime As String
        Dim readColor As Color
        Dim readTick As Long
    End Structure

    Dim CRcount As Long
    Public commandResponse As Boolean
    Dim secondsTotal As Integer
    Dim firstHour As Integer
    Dim firstMinute As Integer
    Dim firstSecond As Integer
    Dim lastHour As Integer
    Dim lastMinute As Integer
    Dim lastSecond As Integer
    Dim SelectedItem As String
    Dim EPCmemory As String
    Dim TIDmemory As String
    Dim ReservedMemory As String
    Dim UserMemory As String
    Dim GlobalString As String
    Dim myItem As ListViewItem
    Dim tagReadIndex As Integer
    Dim tagsRead(0 To 99) As readerInput

    Private Sub FormTerm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim ComPorts() As String
        Dim i As Integer

        ComPorts = IO.Ports.SerialPort.GetPortNames()
        ListView1.ContextMenuStrip = Nothing
        i = 0
        While i < ComPorts.Length
            ComboBoxComm.Items.Add(ComPorts(i))
            i = i + 1
        End While
        CRcount = 0
        GlobalString = ""
        ''''''''''''''''''''''''''''
        SaveFileDialog1.ShowDialog()
        FileOpen(1, SaveFileDialog1.FileName, OpenMode.Output)
        PrintLine(1, SaveFileDialog1.FileName.ToString & " " & DateAndTime.DateString & ControlChars.CrLf)
        FileClose(1)
    End Sub
    Private Sub FormTerm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If SerialPort1.IsOpen Then SerialPort1.Close()
    End Sub
    Private Sub TextBoxSerialIn_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBoxSerialIn.KeyPress
        'Dim str As String
        ' Try to send character
        With SerialPort1
            If .IsOpen = True Then
                Dim OutputData As Char
                OutputData = e.KeyChar
                .Write(OutputData)
            Else
                MsgBox("Port Not Open")             ' Port not open display error
                e.Handled = True
                Exit Sub
            End If
        End With
    End Sub
    
    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim SerStr As String

        SerStr = SerialPort1.ReadExisting()
        Me.Invoke(myDelegate, New Object() {SerStr})
        'myDelegate(SerStr)
    End Sub
    Public Sub UpdateTextBoxSerialInMethod(ByVal str As String)
        Dim i As Integer
        'Dim index As Integer
        'Dim repeatedItem As Integer
        Dim refresh As Boolean
        Dim myLines() As String

        refresh = False
        With TextBoxSerialIn
            ' analize the string
            For i = 0 To str.Length - 1
                If str.Chars(i) = ControlChars.Lf Then
                    .ForeColor = Color.Aqua
                    .Text += "<LF>"
                    GlobalString = ""
                ElseIf str.Chars(i) = ControlChars.Cr Then
                    tagReadIndex += 1
                    TextBoxNumOfTags.Enabled = True
                    TextBoxNumOfTags.Text = tagReadIndex.ToString
                    TextBoxNumOfTags.Enabled = False

                    .ForeColor = Color.Aqua
                    .Text += "<CR> " + TimeString + " " + DateString + " " + tagReadIndex.ToString + ControlChars.CrLf

                    CRcount += 1
                    If CRcount >= 30 Then
                        .Text = .Text.Remove(0, .Text.IndexOf(ControlChars.CrLf) + 1)
                        'myLines = .Lines
                        '.Text = myLines(myLines.Length - 1)

                        CRcount -= 1
                    End If
                    myLines = .Lines

                    If SaveFileDialog1.FileName <> "" Then
                        FileOpen(1, SaveFileDialog1.FileName, OpenMode.Append)
                        PrintLine(1, myLines(myLines.Length - 2).ToString)
                        FileClose(1)
                    End If

                    'For index = 0 To 99
                    'If tagsRead(index).readData = GlobalString Then
                    'If commandResponse = False Then
                    'tagsRead(index).readCount += 1
                    'tagsRead(index).readTime = TimeString
                    'refresh = True
                    'repeatedItem = index
                    'Exit For
                    'End If
                    'End If
                    'Next
                    'If refresh Then
                    'If commandResponse = True Then
                    'FormTagMemory.TextBoxData.Text = GlobalString
                    'GlobalString = ""
                    'commandResponse = False
                    'Else
                    'ListView1.Items.Clear()
                    'For index = 0 To tagReadIndex - 1
                    'myItem = ListView1.Items.Add(tagsRead(index).readData)
                    'myItem.SubItems.Add(tagsRead(index).readCount)
                    'myItem.SubItems.Add(tagsRead(index).readTime)
                    'If index = repeatedItem Then
                    'tagsRead(index).readColor = Color.LightGreen
                    'tagsRead(index).readTick = 0
                    'End If
                    'myItem.BackColor = tagsRead(index).readColor
                    'Next
                    'End If

                    'ElseIf GlobalString.Length < 14 Then
                    'If commandResponse = True Then
                    'If GlobalString.Length > 32 And GlobalString.Length <= 64 Then
                    'FormTagMemory.TextBoxData.Text = GlobalString.Substring(0, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(32)
                    'ElseIf GlobalString.Length > 64 And GlobalString.Length <= 96 Then
                    'FormTagMemory.TextBoxData.Text = GlobalString.Substring(0, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(32, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(64)
                    'ElseIf GlobalString.Length > 96 Then
                    'FormTagMemory.TextBoxData.Text = GlobalString.Substring(0, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(32, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(64, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(96)
                    'Else
                    'FormTagMemory.TextBoxData.Text = GlobalString
                    'End If
                    'commandResponse = False
                    'End If
                    'GlobalString = ""
                    'Else
                    ' Add new entry
                    'If commandResponse = True Then
                    'If GlobalString.Length > 32 And GlobalString.Length <= 64 Then
                    'FormTagMemory.TextBoxData.Text = GlobalString.Substring(0, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(32)
                    'ElseIf GlobalString.Length > 64 And GlobalString.Length <= 96 Then
                    'FormTagMemory.TextBoxData.Text = GlobalString.Substring(0, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(32, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(64)
                    'ElseIf GlobalString.Length > 96 Then
                    'FormTagMemory.TextBoxData.Text = GlobalString.Substring(0, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(32, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(64, 32)
                    'FormTagMemory.TextBoxData.Text += ControlChars.CrLf
                    'FormTagMemory.TextBoxData.Text += GlobalString.Substring(96)
                    'Else
                    'FormTagMemory.TextBoxData.Text = GlobalString
                    'End If
                    'commandResponse = False
                    'ElseIf tagReadIndex < ComboBoxMaxTags.Text Then
                    'tagsRead(tagReadIndex).readData = GlobalString
                    'tagsRead(tagReadIndex).readCount = 1
                    'tagsRead(tagReadIndex).readTime = TimeString
                    'tagsRead(tagReadIndex).readColor = Color.LightGreen
                    'tagsRead(tagReadIndex).readTick = 0

                    'myItem = ListView1.Items.Add(tagsRead(tagReadIndex).readData)
                    'myItem.SubItems.Add(tagsRead(tagReadIndex).readCount)
                    'myItem.SubItems.Add(tagsRead(tagReadIndex).readTime)
                    'myItem.BackColor = tagsRead(tagReadIndex).readColor

                    'If tagReadIndex = 0 Then
                    'firstHour = tagsRead(tagReadIndex).readTime.Substring(0, 2)
                    'firstMinute = tagsRead(tagReadIndex).readTime.Substring(3, 2)
                    'firstSecond = tagsRead(tagReadIndex).readTime.Substring(6, 2)
                    'secondsTotal = 0
                    'End If


                    'If tagReadIndex = ComboBoxMaxTags.Text Then
                    'GlobalString = ComboBoxMaxTags.Text & " unique tags read in "
                    'Dim localSeconds As Integer
                    'localSeconds = secondsTotal

                    'If localSeconds > 59 Then
                    'Dim localMinutes As Integer
                    'localMinutes = localSeconds / 60
                    'GlobalString += localMinutes & " minutes"
                    'localMinutes = localSeconds - (localMinutes * 60)
                    'If localMinutes <> 0 Then
                    'GlobalString += " and " & localMinutes & " seconds"
                    'End If
                    'Else
                    'GlobalString += localSeconds & " seconds"
                    'End If
                    'MsgBox(GlobalString)
                    'End If
                    'End If
                    'GlobalString = ""
                    'End If
                Else
                    .Text += str.Chars(i)
                    GlobalString += str.Chars(i)
                End If
            Next
            .Focus()
            .SelectionStart = .Text.Length
            .SelectionLength = 0
            .ScrollToCaret()

        End With
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim i As Integer
        Dim tagsToRemove As Integer
        Dim validate As Boolean
        Dim Times(3) As Integer
        Dim TimesStr() As String

        If tagReadIndex = 0 Then
            TextBoxNumOfTags.Text = "0"
            Exit Sub
        End If

        'secondsTotal += 1

        validate = False
        tagsToRemove = 0
        TimesStr = ComboBoxTimes.Text.Split(",")
        If TimesStr.Length < 3 Then
            'MsgBox("Invalid time outs")
            Exit Sub
        End If
        Times(0) = TimesStr(0)
        Times(1) = TimesStr(1)
        Times(2) = TimesStr(2)

        If Times(0) > Times(1) Or Times(1) > Times(2) Then
            'MsgBox("Invalid time outs")
            Exit Sub
        End If

        For i = 0 To 1 'tagReadIndex - 1
            tagsRead(i).readTick += 1
            If tagsRead(i).readTick = Times(0) Then
                validate = True
                tagsRead(i).readColor = Color.Yellow
            ElseIf tagsRead(i).readTick = Times(1) Then
                validate = True
                tagsRead(i).readColor = Color.Red
            ElseIf tagsRead(i).readTick >= Times(2) And CheckBoxRemove.Checked = True Then
                validate = True
                If tagReadIndex = 1 Then
                    tagsRead(0).readData = ""
                    tagsRead(0).readCount = 0
                    tagsRead(0).readTime = ""
                    tagsRead(0).readColor = Color.White
                    tagReadIndex = 0
                    tagsToRemove = 1
                    ListView1.Items.Clear()
                    Exit For
                Else
                    For j As Integer = i To tagReadIndex - 1
                        tagsRead(j).readTick = tagsRead(j + 1).readTick
                        tagsRead(j).readData = tagsRead(j + 1).readData
                        tagsRead(j).readCount = tagsRead(j + 1).readCount
                        tagsRead(j).readTime = tagsRead(j + 1).readTime
                        tagsRead(j).readColor = tagsRead(j + 1).readColor
                    Next
                    i -= 1
                    tagReadIndex -= 1
                    TextBoxNumOfTags.Text = tagReadIndex.ToString
                    tagsToRemove += 1
                End If
            End If
        Next
        If validate = True Then
            UpdateMyItems()
        End If
    End Sub
    Private Sub UpdateMyItems()
        ListView1.Items.Clear()
        For i As Integer = 0 To 1 'tagReadIndex - 1
            myItem = ListView1.Items.Add(tagsRead(i).readData)
            myItem.SubItems.Add(tagsRead(i).readCount)
            myItem.SubItems.Add(tagsRead(i).readTime)
            myItem.BackColor = tagsRead(i).readColor
        Next
    End Sub

    Private Sub ButtonConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonConnect.Click
        If ComboBoxComm.Text = "" Then
            MsgBox("Please select port", MsgBoxStyle.Exclamation)
            Exit Sub
        End If

        With SerialPort1
            If ButtonConnect.Text = "Connect" Then
                .PortName = ComboBoxComm.Text
                .ReceivedBytesThreshold = 1
                .BaudRate = ComboBoxBaud.Text
                .DataBits = ComboBoxBits.Text

                ' Parity
                Select Case ComboBoxParity.Text
                    Case "None"
                        .Parity = IO.Ports.Parity.None
                    Case "Even"
                        .Parity = IO.Ports.Parity.Even
                    Case "Mark"
                        .Parity = IO.Ports.Parity.Mark
                    Case "Odd"
                        .Parity = IO.Ports.Parity.Odd
                    Case "Space"
                        .Parity = IO.Ports.Parity.Space
                    Case Else
                        ComboBoxParity.Text = "None"
                        .Parity = IO.Ports.Parity.None
                End Select

                ' Stop Bits
                Select Case ComboBoxStop.Text
                    Case "1"
                        .StopBits = IO.Ports.StopBits.One
                    Case "1.5"
                        .StopBits = IO.Ports.StopBits.OnePointFive
                    Case "2"
                        .StopBits = IO.Ports.StopBits.Two
                    Case Else
                        ComboBoxStop.Text = "1"
                        .StopBits = IO.Ports.StopBits.One
                End Select

                ' Flow Control
                Select Case ComboBoxFlow.Text
                    Case "None"
                        .Handshake = IO.Ports.Handshake.None
                    Case "RTS"
                        .Handshake = IO.Ports.Handshake.RequestToSend
                    Case "RTSXOnXOff"
                        .Handshake = IO.Ports.Handshake.RequestToSendXOnXOff
                    Case "XOnXOff"
                        .Handshake = IO.Ports.Handshake.XOnXOff
                    Case Else
                        ComboBoxFlow.Text = "None"
                        .Handshake = IO.Ports.Handshake.None
                End Select
                Try
                    .Open()
                Catch ex As Exception

                End Try
                If .IsOpen Then
                    TextBoxSerialIn.Focus()
                    ButtonConnect.Text = "Disconnect"
                    'player.Play()              ' Safari and WAP
                Else
                    MsgBox("Port open failed", MsgBoxStyle.Exclamation)
                End If
            Else
                .Close()
                ButtonConnect.Text = "Connect"
                'player.Play()              ' Safari and WAP
            End If
        End With
    End Sub
    Private Sub ListView1_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
        Handles ListView1.MouseClick

        If e.Button = Windows.Forms.MouseButtons.Right Then
            ListView1.ContextMenuStrip = Nothing 'if you dont set it to nothing, default context menu will be shown
            ContextMenuStrip1.Show(MousePosition) ' show your context menu
            SelectedItem = ListView1.SelectedItems(0).ToString
            'SelectedItem.
        End If
    End Sub

    Private Sub MenuItemTagMemory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemTagMemory.Click
        Dim i As Integer
        Dim j As Integer

        UserMemory = ""
        TIDmemory = ""
        ReservedMemory = ""

        i = SelectedItem.IndexOf("{") + 1
        j = SelectedItem.IndexOf("}")
        j -= i
        FormTagMemory.Show(Me)
        FormTagMemory.TextBoxEPCbitLenght.Text = (j * 4).ToString
        FormTagMemory.TextBoxEPCbitLenght.Enabled = False
        SelectedItem = SelectedItem.Substring(i, j)
        EPCmemory = SelectedItem
        FormTagMemory.TextBoxEPC.Text = SelectedItem
        FormTagMemory.TextBoxEPC.Enabled = False
        commandResponse = False
    End Sub

    Private Sub ButtonScanPorts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonScanPorts.Click
        Dim ComPorts() As String
        Dim i As Integer

        If SerialPort1.IsOpen = True Then
            MsgBox("Close current port connection first")
            Exit Sub
        End If
        ComboBoxComm.Items.Clear()
        ComPorts = IO.Ports.SerialPort.GetPortNames()
        'ListView1.ContextMenuStrip = Nothing
        i = 0
        While i < ComPorts.Length
            ComboBoxComm.Items.Add(ComPorts(i))
            i = i + 1
        End While
    End Sub

    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click
        'If tagReadIndex < 1 Then
        'MsgBox("Nothing to save")
        'Exit Sub
        'End If
        SaveFileDialog1.ShowDialog()
        'If SaveFileDialog1.FileName <> "" Then
        'FileOpen(1, SaveFileDialog1.FileName, OpenMode.Output)
        ' PrintLine(1, "") Save data
        'For i As Integer = 0 To tagReadIndex - 1
        'PrintLine(1, tagsRead(i).readData.ToString & " " & tagsRead(i).readTime.ToString & " " & DateAndTime.DateString)
        'Next
        'End If
    End Sub
End Class
